// $Id: Packet.java,v 1.1 2001/05/17 20:17:14 pcharles Exp $

/***************************************************************************
 * Copyright (C) 2001, Patrick Charles and Jonas Lehmann                   *
 * Distributed under the Mozilla Public License                            *
 *   http://www.mozilla.org/NPL/MPL-1.1.txt                                *
 ***************************************************************************/
package net.sourceforge.jpcap.net;

import net.ultrametrics.util.ByteArray;


/**
 * A packet.
 * <p>
 * Encapsulation for data captured on a network device by PacketCapture.
 *
 * @author Patrick Charles and Jonas Lehmann
 * @version $Revision: 1.1 $
 * @lastModifiedBy $Author: pcharles $
 * @lastModifiedAt $Date: 2001/05/17 20:17:14 $
 */
public class Packet
{
  /**
   * Create a new packet.
   */
  public Packet(int length, int caplen, int seconds, int useconds, 
                byte [] data) {
    this.length = length;
    this.caplen = caplen;
    this.seconds = seconds;
    this.useconds = useconds;
    this.data = data;
  }


  private void setLength(int length) {
    this.length = length;
  }

  public int getLength() {
    return length;
  }

  /**
   * Convert this packet to a readable string.
   */
  public String toString() {
    StringBuffer buffer = new StringBuffer();
    buffer.append("[Packet: ");
    buffer.append("l = " + caplen + " of " + length + ", ");
    buffer.append("t = " + seconds + "." + useconds + "s, ");
    buffer.append("d = ");
    // todo: comment this in, and it causes a NullPointerException
    //       calling toString() on a byte[] should never be able to 
    //       cause a npe, but evidently something is screwed up internally
    //       due to the conversion of the data from jpcap.
    //
    //  buffer.append(data);
    buffer.append(ByteArray.toString(data));
    buffer.append(']');

    return buffer.toString();
  }


  private int length;
  private int caplen;
  private int seconds;
  private int useconds;
  private byte [] data;

  private String _rcsid = 
    "$Id: Packet.java,v 1.1 2001/05/17 20:17:14 pcharles Exp $";
}
